import React from 'react';
import type { ToasterPublicMethods } from '@gravity-ui/uikit';
import { ClassNameProps } from '../classname';
import type { Editor } from './Editor';
import { MToolbarData, MToolbarSingleItemData } from './config/markup';
import { WToolbarData, WToolbarItemData } from './config/wysiwyg';
import { EditorSettingsProps } from './settings';
export declare const cnEditorComponent: import("@bem-react/classname").ClassNameFormatter;
export declare type YfmEditorViewProps = ClassNameProps & {
    editor?: Editor;
    autofocus?: boolean;
    markupToolbarConfig?: MToolbarData;
    wysiwygToolbarConfig?: WToolbarData;
    markupHiddenActionsConfig?: MToolbarSingleItemData[];
    wysiwygHiddenActionsConfig?: WToolbarItemData[];
    /** @default true */
    settingsVisible?: boolean;
    toaster: ToasterPublicMethods;
    stickyToolbar: boolean;
};
export declare const YfmEditorView: React.ForwardRefExoticComponent<ClassNameProps & {
    editor?: Editor | undefined;
    autofocus?: boolean | undefined;
    markupToolbarConfig?: MToolbarData | undefined;
    wysiwygToolbarConfig?: WToolbarData | undefined;
    markupHiddenActionsConfig?: MToolbarSingleItemData[] | undefined;
    wysiwygHiddenActionsConfig?: WToolbarItemData[] | undefined;
    /** @default true */
    settingsVisible?: boolean | undefined;
    toaster: ToasterPublicMethods;
    stickyToolbar: boolean;
} & React.RefAttributes<HTMLDivElement>>;
export declare function Settings(props: EditorSettingsProps & {
    stickyToolbar: boolean;
}): JSX.Element;
