import { CMFilesUploadPresenter, CMFilesUploadPresenterParams } from './FilesUploadPresenter';
export interface CMFilesUploader {
    upload(files: ArrayLike<File>): void;
    destroy(): void;
}
export declare type CMFilesUploadManagerParams = Pick<CMFilesUploadPresenterParams, 'cm' | 'uploadHandler' | 'reactRenderer' | 'needDimmensionsForImages'>;
export declare class CMFilesUploadManager implements CMFilesUploader, CMFilesUploadPresenterParams {
    readonly cm: CMFilesUploadManagerParams['cm'];
    readonly uploadHandler: CMFilesUploadManagerParams['uploadHandler'];
    readonly reactRenderer: CMFilesUploadManagerParams['reactRenderer'];
    readonly needDimmensionsForImages: boolean;
    private readonly _presenters;
    constructor(params: CMFilesUploadManagerParams);
    upload(files: ArrayLike<File>): void;
    destroy(): void;
    onAllSettled(presenter: CMFilesUploadPresenter): void;
}
