import type CodeMirror from 'codemirror';
import { ReactRenderStorage } from '../../extensions';
import type { FileUploadHandler } from '../../utils/upload';
export interface CMFilesUploadPresenterParams {
    readonly cm: CodeMirror.Editor;
    readonly uploadHandler: FileUploadHandler;
    readonly reactRenderer: ReactRenderStorage;
    onAllSettled(presenter: CMFilesUploadPresenter): void;
    needDimmensionsForImages: boolean;
}
export declare class CMFilesUploadPresenter {
    private readonly _params;
    private readonly _uploadFiles;
    private __reactWidget;
    private readonly _reactContainer;
    private _cmWidget;
    private readonly _initialPosition;
    private _state;
    private get _reactWidget();
    constructor(params: CMFilesUploadPresenterParams);
    run(files: ArrayLike<File>): this;
    destroy(): void;
    private _onFileUpload;
    private _onFileFail;
    private _onReUploadClick;
    private _onCloseClick;
    private _insertFileMarkup;
    private _removeFileFromView;
    private _checkIfAllFilesUploaded;
    private _isInitialCursorPos;
    private _scheduleWidgetChange;
}
