"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadImage = exports.getImageDimensions = void 0;
async function getImageDimensions(imgFile) {
    const img = await loadImage(imgFile);
    return { width: img.naturalWidth, height: img.naturalHeight };
}
exports.getImageDimensions = getImageDimensions;
async function loadImage(imgFile) {
    return new Promise((resolve, reject) => {
        const img = document.createElement('img');
        img.src = URL.createObjectURL(imgFile);
        img.onload = () => {
            URL.revokeObjectURL(img.src);
            resolve(img);
        };
        img.onerror = (_e, _s, _l, _c, error) => reject(error);
    });
}
exports.loadImage = loadImage;
