"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mHiddenData = exports.mTabsItemData = exports.mHruleItemData = exports.mToolbarConfig = exports.mMermaidButton = exports.mMathListItem = exports.mMathListConfig = exports.mCodeListConfig = exports.mTableButton = exports.mCutButton = exports.mQuoteButton = exports.mNoteButton = exports.mLinkButton = exports.mListMoveListConfig = exports.mCheckboxButton = exports.mListsListConfig = exports.mHeadingListConfig = exports.mBiusGroupConfig = exports.mItalicGroupItem = exports.mBoldGroupItem = exports.mHistoryGroupConfig = void 0;
const menubar_1 = require("../../i18n/menubar");
const active_1 = require("../../markup/active");
const commands_1 = require("../../markup/commands");
const shortcuts_1 = require("../../shortcuts");
const types_1 = require("../../toolbar/types");
const MToolbarColors_1 = require("../toolbar/markup/MToolbarColors");
const MToolbarFile_1 = require("../toolbar/markup/MToolbarFile");
const MToolbarImage_1 = require("../toolbar/markup/MToolbarImage");
const MToolbarLink_1 = require("../toolbar/markup/MToolbarLink");
const action_names_1 = require("./action-names");
const icons_1 = require("./icons");
const isActiveFn = () => false;
const isEnableFn = () => true;
exports.mHistoryGroupConfig = [
    {
        id: action_names_1.ActionName.undo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'undo'),
        icon: icons_1.icons.undo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Undo),
        exec: (e) => e.cm.undo(),
        isActive: isActiveFn,
        isEnable: (e) => e.cm.historySize().undo > 0,
    },
    {
        id: action_names_1.ActionName.redo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'redo'),
        icon: icons_1.icons.redo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Redo),
        exec: (e) => e.cm.redo(),
        isActive: isActiveFn,
        isEnable: (e) => e.cm.historySize().redo > 0,
    },
];
/** Bold, Italic, Underline, Strike buttons group */
exports.mBoldGroupItem = {
    id: action_names_1.ActionName.bold,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'bold'),
    icon: icons_1.icons.bold,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Bold),
    exec: (e) => (0, commands_1.wrapToBold)(e.cm),
    isActive: (e) => (0, active_1.isBoldActive)(e.cm),
    isEnable: isEnableFn,
};
exports.mItalicGroupItem = {
    id: action_names_1.ActionName.italic,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'italic'),
    icon: icons_1.icons.italic,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Italic),
    exec: (e) => (0, commands_1.wrapToItalic)(e.cm),
    isActive: (e) => (0, active_1.isItalicActive)(e.cm),
    isEnable: isEnableFn,
};
exports.mBiusGroupConfig = [
    exports.mBoldGroupItem,
    exports.mItalicGroupItem,
    {
        id: action_names_1.ActionName.underline,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'underline'),
        icon: icons_1.icons.underline,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Underline),
        exec: (e) => (0, commands_1.wrapToUnderline)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
    {
        id: action_names_1.ActionName.strike,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'strike'),
        icon: icons_1.icons.strikethrough,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Strike),
        exec: (e) => (0, commands_1.wrapToStrike)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
    {
        id: action_names_1.ActionName.mono,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'mono'),
        icon: icons_1.icons.mono,
        exec: (e) => (0, commands_1.wrapToMonospace)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
    {
        id: action_names_1.ActionName.mark,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'mark'),
        icon: icons_1.icons.mark,
        exec: (e) => (0, commands_1.wrapToMark)(e.cm),
        isActive: isActiveFn,
        isEnable: isEnableFn,
    },
];
exports.mHeadingListConfig = {
    icon: icons_1.icons.headline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'heading'),
    data: [
        {
            id: action_names_1.ActionName.heading1,
            title: menubar_1.i18n.bind(null, 'heading1'),
            icon: icons_1.icons.h1,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading1),
            exec: (e) => (0, commands_1.toH1)(e.cm),
            isActive: (e) => (0, active_1.isH1Active)(e.cm),
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading2,
            title: menubar_1.i18n.bind(null, 'heading2'),
            icon: icons_1.icons.h2,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading2),
            exec: (e) => (0, commands_1.toH2)(e.cm),
            isActive: (e) => (0, active_1.isH2Active)(e.cm),
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading3,
            title: menubar_1.i18n.bind(null, 'heading3'),
            icon: icons_1.icons.h3,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading3),
            exec: (e) => (0, commands_1.toH3)(e.cm),
            isActive: (e) => (0, active_1.isH3Active)(e.cm),
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading4,
            title: menubar_1.i18n.bind(null, 'heading4'),
            icon: icons_1.icons.h4,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading4),
            exec: (e) => (0, commands_1.toH4)(e.cm),
            isActive: (e) => (0, active_1.isH4Active)(e.cm),
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading5,
            title: menubar_1.i18n.bind(null, 'heading5'),
            icon: icons_1.icons.h5,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading5),
            exec: (e) => (0, commands_1.toH5)(e.cm),
            isActive: (e) => (0, active_1.isH5Active)(e.cm),
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.heading6,
            title: menubar_1.i18n.bind(null, 'heading6'),
            icon: icons_1.icons.h6,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading6),
            exec: (e) => (0, commands_1.toH6)(e.cm),
            isActive: (e) => (0, active_1.isH6Active)(e.cm),
            isEnable: isEnableFn,
        },
    ],
};
exports.mListsListConfig = {
    icon: icons_1.icons.bulletList,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'list'),
    data: [
        {
            id: action_names_1.ActionName.bulletList,
            title: menubar_1.i18n.bind(null, 'ulist'),
            icon: icons_1.icons.bulletList,
            exec: (e) => (0, commands_1.toBulletList)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.orderedList,
            title: menubar_1.i18n.bind(null, 'olist'),
            icon: icons_1.icons.orderedList,
            exec: (e) => (0, commands_1.toOrderedList)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mCheckboxButton = {
    id: action_names_1.ActionName.checkbox,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'checkbox'),
    icon: icons_1.icons.checklist,
    exec: (e) => (0, commands_1.toCheckbox)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mListMoveListConfig = {
    icon: icons_1.icons.lift,
    withArrow: true,
    title: 'Move list item',
    data: [
        {
            id: action_names_1.ActionName.sinkListItem,
            title: menubar_1.i18n.bind(null, 'list__action_sink'),
            icon: icons_1.icons.sink,
            exec: (e) => (0, commands_1.sinkListItem)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.liftListItem,
            title: menubar_1.i18n.bind(null, 'list__action_lift'),
            icon: icons_1.icons.lift,
            exec: (e) => (0, commands_1.liftListItem)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mLinkButton = {
    id: action_names_1.ActionName.link,
    type: types_1.ToolbarDataType.ReactComponent,
    component: MToolbarLink_1.MToolbarLink,
    width: 28,
};
exports.mNoteButton = {
    id: action_names_1.ActionName.yfm_note,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'note'),
    icon: icons_1.icons.note,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Note),
    exec: (e) => (0, commands_1.wrapToNote)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mQuoteButton = {
    id: action_names_1.ActionName.quote,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'quote'),
    icon: icons_1.icons.quote,
    exec: (e) => (0, commands_1.toQuote)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mCutButton = {
    id: action_names_1.ActionName.yfm_cut,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'cut'),
    icon: icons_1.icons.cut,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Cut),
    exec: (e) => (0, commands_1.wrapToCut)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mTableButton = {
    id: action_names_1.ActionName.table,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'table'),
    icon: icons_1.icons.table,
    exec: (e) => (0, commands_1.insertTable)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
exports.mCodeListConfig = {
    icon: icons_1.icons.code,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'code'),
    data: [
        {
            id: action_names_1.ActionName.code_inline,
            title: menubar_1.i18n.bind(null, 'code_inline'),
            icon: icons_1.icons.code,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Code),
            exec: (e) => (0, commands_1.toInlineCode)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.code_block,
            title: menubar_1.i18n.bind(null, 'codeblock'),
            icon: icons_1.icons.codeBlock,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.CodeBlock),
            exec: (e) => (0, commands_1.toCodeBlock)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mMathListConfig = {
    icon: icons_1.icons.functionInline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'math'),
    data: [
        {
            id: action_names_1.ActionName.math_inline,
            title: menubar_1.i18n.bind(null, 'math_inline'),
            icon: icons_1.icons.functionInline,
            exec: (e) => (0, commands_1.wrapToMathInline)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
        {
            id: action_names_1.ActionName.math_block,
            title: menubar_1.i18n.bind(null, 'math_block'),
            icon: icons_1.icons.functionBlock,
            exec: (e) => (0, commands_1.wrapToMathBlock)(e.cm),
            isActive: isActiveFn,
            isEnable: isEnableFn,
        },
    ],
};
exports.mMathListItem = Object.assign({ id: 'math', type: types_1.ToolbarDataType.ListButton }, exports.mMathListConfig);
exports.mMermaidButton = {
    id: action_names_1.ActionName.mermaid,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'mermaid'),
    icon: icons_1.icons.mermaid,
    exec: (e) => (0, commands_1.toMermaid)(e.cm),
    isActive: isActiveFn,
    isEnable: isEnableFn,
};
/** prepared markup toolbar config */
exports.mToolbarConfig = [
    exports.mHistoryGroupConfig,
    exports.mBiusGroupConfig,
    [
        Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.mHeadingListConfig),
        Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.mListsListConfig),
        {
            id: 'colorify',
            type: types_1.ToolbarDataType.ReactComponent,
            component: MToolbarColors_1.MToolbarColors,
            width: 42,
        },
        exports.mLinkButton,
        exports.mNoteButton,
        exports.mCutButton,
        exports.mQuoteButton,
        Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.mCodeListConfig),
    ],
    [
        {
            id: 'image',
            type: types_1.ToolbarDataType.ReactComponent,
            component: MToolbarImage_1.MToolbarImage,
            width: 28,
        },
        {
            id: 'file',
            type: types_1.ToolbarDataType.ReactComponent,
            component: MToolbarFile_1.MToolbarFile,
            width: 28,
        },
        exports.mTableButton,
        exports.mCheckboxButton,
    ],
];
exports.mHruleItemData = {
    id: 'hrule',
    title: menubar_1.i18n.bind(null, 'hrule'),
    icon: icons_1.icons.horizontalRule,
    type: types_1.ToolbarDataType.SingleButton,
    exec: (e) => (0, commands_1.toHr)(e.cm),
    isActive: (e) => (0, active_1.isBoldActive)(e.cm),
    isEnable: isEnableFn,
};
exports.mTabsItemData = {
    id: 'tabs',
    title: menubar_1.i18n.bind(null, 'tabs'),
    icon: icons_1.icons.tabs,
    type: types_1.ToolbarDataType.SingleButton,
    exec: (e) => (0, commands_1.toTabs)(e.cm),
    isActive: (e) => (0, active_1.isBoldActive)(e.cm),
    isEnable: isEnableFn,
};
exports.mHiddenData = [exports.mHruleItemData, exports.mTabsItemData];
