"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MToolbarFile = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const commands_1 = require("../../../markup/commands");
const ToolbarFile_1 = require("../custom/ToolbarFile");
const context_1 = require("./context");
const MToolbarFile = ({ focus, onClick, editor, className }) => {
    const { uploadHandler } = (0, context_1.useMarkupToolbarContext)();
    return (react_1.default.createElement(ToolbarFile_1.ToolbarFile, { focus: focus, onClick: onClick, className: className, active: false, enable: true, onSubmit: (fileParams) => (0, commands_1.insertFiles)(editor.cm, [fileParams]), uploadHandler: uploadHandler, onSuccessUpload: (res) => {
            (0, commands_1.insertFiles)(editor.cm, res.success.map(({ result, file }) => {
                var _a, _b;
                return ({
                    src: result.url,
                    name: (_a = result.name) !== null && _a !== void 0 ? _a : file.name,
                    type: (_b = result.type) !== null && _b !== void 0 ? _b : file.type,
                });
            }));
        } }));
};
exports.MToolbarFile = MToolbarFile;
