"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WToolbarLink = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const ToolbarLink_1 = require("../custom/ToolbarLink");
const WToolbarLink = ({ focus, onClick, editor, className }) => {
    const action = editor.actions.link;
    const active = action.isActive();
    const enable = action.isEnable();
    const meta = action.meta();
    return (react_1.default.createElement(ToolbarLink_1.ToolbarLink, { focus: focus, onClick: onClick, className: className, active: active, enable: enable, formInitialText: meta.text(), formReadOnlyText: meta.hasSelection, onSubmit: (url, text) => {
            action.run({ href: url, text: meta.hasSelection ? '' : text });
        }, removeLink: () => {
            action.run({ href: '' });
        } }));
};
exports.WToolbarLink = WToolbarLink;
