import { ExtensionAuto } from '../core';
import { BasePresetOptions, BehaviorPresetOptions, MarkdownBlocksPresetOptions, MarkdownMarksPresetOptions, YfmPresetOptions } from '../extensions';
import { EditorModeKeymapOptions } from '../extensions/behavior/EditorModeKeymap';
import type { FileUploadHandler } from '../utils/upload';
export declare type ExtensionsOptions = BasePresetOptions & MarkdownMarksPresetOptions & Omit<MarkdownBlocksPresetOptions, 'image' | 'heading'> & YfmPresetOptions & BehaviorPresetOptions;
export declare type BundlePresetOptions = ExtensionsOptions & EditorModeKeymapOptions & {
    mdBreaks?: boolean;
    fileUploadHandler?: FileUploadHandler;
    /**
     * If we need to set dimensions for uploaded images
     *
     * @default false
     */
    needToSetDimensionsForUploadedImages?: boolean;
};
export declare const BundlePreset: ExtensionAuto<BundlePresetOptions>;
