"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.codeLangSelectTooltipViewCreator = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const markdown_1 = require("../../../../extensions/markdown");
const codeblock_1 = require("../../../../i18n/codeblock");
const placeholder_1 = require("../../../../i18n/placeholder");
const BaseTooltip_1 = require("../../../../plugins/BaseTooltip");
const toolbar_1 = require("../../../../toolbar");
const remove_node_1 = require("../../../../utils/remove-node");
const const_1 = require("../const");
const CodeMenu = ({ view, pos, node, selectItems, mapping }) => {
    var _a;
    const lang = node.attrs[const_1.langAttr];
    const value = (_a = mapping[lang]) !== null && _a !== void 0 ? _a : lang;
    const handleClick = (type) => {
        view.focus();
        if (type === value)
            return;
        view.dispatch(view.state.tr.setNodeMarkup(pos, null, {
            [const_1.langAttr]: type,
        }));
    };
    return (react_1.default.createElement(uikit_1.Select, { size: "m", width: "max", value: [value], onUpdate: (v) => handleClick(v[0]), options: selectItems, filterable: true, filterPlaceholder: (0, placeholder_1.i18n)('select_filter'), popupClassName: "ye-code-block__select-popup", className: "ye-code-block__select-button", renderEmptyOptions: () => (react_1.default.createElement("div", { className: "ye-code-block__select-empty" }, (0, codeblock_1.i18n)('empty_option'))) }));
};
const codeLangSelectTooltipViewCreator = (view, langItems, mapping = {}) => {
    return new BaseTooltip_1.BaseTooltipPluginView(view, {
        idPrefix: 'code-block-tooltip',
        nodeType: (0, markdown_1.codeBlockType)(view.state.schema),
        popupPlacement: ['bottom', 'top'],
        content: (view, { node, pos }) => (react_1.default.createElement(toolbar_1.Toolbar, { editor: {}, focus: () => view.focus(), className: "ye-code-block-toolbar", data: [
                [
                    {
                        id: 'code-block-type',
                        type: toolbar_1.ToolbarDataType.ReactComponent,
                        component: () => (react_1.default.createElement(CodeMenu, { view: view, pos: pos, node: node, selectItems: langItems, mapping: mapping })),
                        width: 28,
                    },
                ],
                [
                    {
                        id: 'code-block-remove',
                        icon: { data: icons_1.TrashBin },
                        title: (0, codeblock_1.i18n)('remove'),
                        type: toolbar_1.ToolbarDataType.SingleButton,
                        isActive: () => false,
                        isEnable: () => true,
                        exec: () => (0, remove_node_1.removeNode)({
                            pos: pos,
                            node: node,
                            tr: view.state.tr,
                            dispatch: view.dispatch.bind(view),
                        }),
                    },
                ],
            ] })),
    });
};
exports.codeLangSelectTooltipViewCreator = codeLangSelectTooltipViewCreator;
