"use strict";
var _YCThemeStore_type, _YCThemeStore_theme;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ycThemeWatcherPlugin = exports.YCThemeStore = void 0;
const tslib_1 = require("tslib");
const uikit_1 = require("@gravity-ui/uikit");
const prosemirror_state_1 = require("prosemirror-state");
const event_emitter_1 = require("../../../../utils/event-emitter");
const ReactRenderer_1 = require("../../ReactRenderer");
class YCThemeStore extends event_emitter_1.EventEmitter {
    constructor() {
        super(...arguments);
        _YCThemeStore_type.set(this, 'light');
        _YCThemeStore_theme.set(this, 'light');
    }
    get type() {
        return tslib_1.__classPrivateFieldGet(this, _YCThemeStore_type, "f");
    }
    get theme() {
        return tslib_1.__classPrivateFieldGet(this, _YCThemeStore_theme, "f");
    }
    setType(type) {
        if (tslib_1.__classPrivateFieldGet(this, _YCThemeStore_type, "f") !== type) {
            tslib_1.__classPrivateFieldSet(this, _YCThemeStore_type, type, "f");
            this.emit('change-type', type);
        }
    }
    setTheme(theme) {
        if (tslib_1.__classPrivateFieldGet(this, _YCThemeStore_theme, "f") !== theme) {
            tslib_1.__classPrivateFieldSet(this, _YCThemeStore_theme, theme, "f");
            this.emit('change-theme', theme);
        }
    }
}
exports.YCThemeStore = YCThemeStore;
_YCThemeStore_type = new WeakMap(), _YCThemeStore_theme = new WeakMap();
const ycThemeWatcherPlugin = (themeStore) => new prosemirror_state_1.Plugin({
    view: (view) => {
        const item = (0, ReactRenderer_1.getReactRendererFromState)(view.state).createItem('yc-theme-watcher', () => {
            const type = (0, uikit_1.useThemeType)();
            const theme = (0, uikit_1.useThemeValue)();
            themeStore.setType(type);
            themeStore.setTheme(theme);
            return null;
        });
        return {
            destroy() {
                item.remove();
            },
        };
    },
});
exports.ycThemeWatcherPlugin = ycThemeWatcherPlugin;
