"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getModeMIME = exports.getUniqueModeNames = exports.modeMimes = void 0;
require("codemirror/mode/clike/clike");
require("codemirror/mode/css/css");
require("codemirror/mode/diff/diff");
require("codemirror/mode/go/go");
require("codemirror/mode/htmlmixed/htmlmixed");
require("codemirror/mode/javascript/javascript");
require("codemirror/mode/jsx/jsx");
require("codemirror/mode/markdown/markdown");
require("codemirror/mode/python/python");
require("codemirror/mode/rust/rust");
require("codemirror/mode/shell/shell");
require("codemirror/mode/sql/sql");
exports.modeMimes = {
    text: 'text/text',
    // 'codemirror/mode/diff/diff'
    diff: 'text/x-diff',
    // codemirror/mode/markdown/markdown
    md: 'text/markdown',
    markdown: 'text/markdown',
    // codemirror/mode/javascript/javascript
    json: 'application/json',
    js: 'text/javascript',
    ts: 'text/typescript',
    javascript: 'text/javascript',
    typescript: 'text/typescript',
    // // codemirror/mode/jsx/jsx
    jsx: 'text/jsx',
    tsx: 'text/typescript-jsx',
    // codemirror/mode/python/python
    python: 'text/x-python',
    // codemirror/mode/css/css
    css: 'text/css',
    scss: 'text/x-scss',
    less: 'text/x-less',
    gss: 'text/x-gss',
    // codemirror/mode/clike/clike
    c: 'text/x-csrc',
    cpp: 'text/x-c++src',
    'c++': 'text/x-c++src',
    java: 'text/x-java',
    cs: 'text/x-csharp',
    'c#': 'text/x-csharp',
    csharp: 'text/x-csharp',
    scala: 'text/x-scala',
    kotlin: 'text/x-kotlin',
    // TODO: add more clike langs support
    // 'codemirror/mode/go/go'
    go: 'text/x-go',
    // 'codemirror/mode/rust/rust'
    rust: 'text/x-rustsrc',
    // 'codemirror/mode/sql/sql'
    sql: 'text/x-sql',
    mysql: 'text/x-mysql',
    postgresql: 'text/x-pgsql',
    pg: 'text/x-pgsql',
    // 'codemirror/mode/shell/shell'
    shell: 'application/x-sh',
    // codemirror/mode/htmlmixed/htmlmixed
    html: 'text/html',
};
const getUniqueModeNames = () => {
    const names = {};
    for (const modeName in exports.modeMimes) {
        if (exports.modeMimes[modeName]) {
            const modeMime = exports.modeMimes[modeName];
            const oldName = names[exports.modeMimes[modeMime]];
            if ((oldName && oldName.length < modeName.length) || !oldName)
                names[modeMime] = modeName;
        }
    }
    return Object.values(names);
};
exports.getUniqueModeNames = getUniqueModeNames;
function getModeMIME(langValue) {
    return exports.modeMimes[langValue] || 'text/plain';
}
exports.getModeMIME = getModeMIME;
