"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImgSizeAdditions = void 0;
const prosemirror_state_1 = require("prosemirror-state");
const markdown_1 = require("../../../extensions/markdown");
const react_node_view_1 = require("../../../react-utils/react-node-view");
const ImagePaste_1 = require("./ImagePaste");
const ImageWidget_1 = require("./ImageWidget");
const NodeView_1 = require("./NodeView/NodeView");
const const_1 = require("./const");
const ImgSizeAdditions = (builder, opts) => {
    builder.use(ImageWidget_1.ImageWidget, {
        imageUploadHandler: opts.imageUploadHandler,
        needToSetDimensionsForUploadedImages: Boolean(opts.needToSetDimensionsForUploadedImages),
    });
    if (opts.imageUploadHandler) {
        builder.use(ImagePaste_1.ImagePaste, {
            imageUploadHandler: opts.imageUploadHandler,
            needDimmensions: Boolean(opts.needToSetDimensionsForUploadedImages),
        });
    }
    builder.addPlugin((deps) => new prosemirror_state_1.Plugin({
        key: const_1.imageRendererKey,
        state: {
            init: () => undefined,
            apply: (tr) => {
                return tr.getMeta(const_1.imageRendererKey);
            },
        },
        props: {
            nodeViews: {
                [markdown_1.imageNodeName]: (0, react_node_view_1.reactNodeViewFactory)(NodeView_1.ImageNodeView, {
                    isInline: true,
                    reactNodeWrapperCn: (0, NodeView_1.cnImgSizeNodeView)('wrapper'),
                })(deps),
            },
        },
    }));
};
exports.ImgSizeAdditions = ImgSizeAdditions;
