"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.innerActions = void 0;
const markdown_1 = require("../../../../extensions/markdown");
const table_utils_1 = require("../../../../table-utils");
const actions_1 = require("../../../../utils/actions");
const cellAlign_1 = require("./cellAlign");
const addRowAfter = (state, dispatch, view) => {
    if (!markdown_1.TableHelpers.findParentBody(state)) {
        return false; // TODO: process when cursor is inside thead
    }
    return (0, table_utils_1.addRowAfter)(state, dispatch, view);
};
const addRow = {
    isEnable: addRowAfter,
    run: addRowAfter,
};
const deleteRow = {
    isEnable: table_utils_1.removeCurrentRow,
    run: table_utils_1.removeCurrentRow,
};
const addColumn = {
    isEnable: table_utils_1.addColumnAfter,
    run: table_utils_1.addColumnAfter,
};
const deleteColumn = {
    isEnable: table_utils_1.removeCurrentColumn,
    run: table_utils_1.removeCurrentColumn,
};
exports.innerActions = (0, actions_1.defineActions)({
    setCellLeftAlign: cellAlign_1.setCellLeftAlign,
    setCellCenterAlign: cellAlign_1.setCellCenterAlign,
    setCellRightAlign: cellAlign_1.setCellRightAlign,
    addRow,
    deleteRow,
    addColumn,
    deleteColumn,
    deleteTable: markdown_1.TableActions.deleteTableAction,
});
