"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BehaviorPreset = void 0;
const tslib_1 = require("tslib");
const lodash_1 = require("../../lodash");
const Emoji_1 = require("../yfm/Emoji");
const ClicksOnEdges_1 = require("./ClicksOnEdges");
const Clipboard_1 = require("./Clipboard");
const CodeBlockHighlight_1 = require("./CodeBlockHighlight");
const CommandMenu_1 = require("./CommandMenu");
const Cursor_1 = require("./Cursor");
const FilePaste_1 = require("./FilePaste");
const History_1 = require("./History");
const ImgSizeAdditions_1 = require("./ImgSizeAdditions");
const LinkEnhance_1 = require("./LinkEnhance");
const Placeholder_1 = require("./Placeholder");
const ReactRenderer_1 = require("./ReactRenderer");
const Selection_1 = require("./Selection");
const SelectionContext_1 = require("./SelectionContext");
const TableContext_1 = require("./TableContext");
const WidgetDecoration_1 = require("./WidgetDecoration");
const YfmFileAdditions_1 = require("./YfmFileAdditions");
const YfmNoteTooltip_1 = require("./YfmNoteTooltip");
const YfmTableAdditions_1 = require("./YfmTableAdditions");
tslib_1.__exportStar(require("./Cursor"), exports);
tslib_1.__exportStar(require("./History"), exports);
tslib_1.__exportStar(require("./Clipboard"), exports);
tslib_1.__exportStar(require("./Selection"), exports);
tslib_1.__exportStar(require("./Placeholder"), exports);
tslib_1.__exportStar(require("./ReactRenderer"), exports);
const BehaviorPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    builder
        .use(Selection_1.Selection)
        .use(Placeholder_1.Placeholder, (_a = opts.placeholder) !== null && _a !== void 0 ? _a : {})
        .use(Cursor_1.Cursor, (_b = opts.cursor) !== null && _b !== void 0 ? _b : {})
        .use(History_1.History, (_c = opts.history) !== null && _c !== void 0 ? _c : {})
        .use(Clipboard_1.Clipboard, (_d = opts.clipboard) !== null && _d !== void 0 ? _d : {})
        .use(ReactRenderer_1.ReactRendererExtension, opts.reactRenderer);
    builder.use(WidgetDecoration_1.WidgetDecoration).use(SelectionContext_1.SelectionContext, (_e = opts.selectionContext) !== null && _e !== void 0 ? _e : {});
    builder.use(TableContext_1.TableContextExtension).use(LinkEnhance_1.LinkEnhance, (_f = opts.link) !== null && _f !== void 0 ? _f : {});
    if ((0, lodash_1.isFunction)(opts.codeBlock)) {
        builder.use(opts.codeBlock);
    }
    else {
        builder.use(CodeBlockHighlight_1.CodeBlockHighlight, (_g = opts.codeBlock) !== null && _g !== void 0 ? _g : {});
    }
    builder
        .use(ImgSizeAdditions_1.ImgSizeAdditions, (_h = opts.imgSize) !== null && _h !== void 0 ? _h : {})
        // .use(YfmHeadingAdditions)
        .use(YfmNoteTooltip_1.YfmNoteTooltip)
        .use(YfmFileAdditions_1.YfmFileAdditions, (_j = opts.yfmFile) !== null && _j !== void 0 ? _j : {})
        .use(YfmTableAdditions_1.YfmTableAdditions);
    if (opts.emoji) {
        builder.use(Emoji_1.Emoji, opts.emoji);
    }
    if (opts.commandMenu)
        builder.use(CommandMenu_1.CommandMenu, opts.commandMenu);
    builder.use(FilePaste_1.FilePaste);
    builder.use(ClicksOnEdges_1.ClicksOnEdges);
};
exports.BehaviorPreset = BehaviorPreset;
