import type CodeMirror from 'codemirror';
export declare const wrapToBold: (cm: CodeMirror.Editor) => void;
export declare const wrapToItalic: (cm: CodeMirror.Editor) => void;
export declare const wrapToStrike: (cm: CodeMirror.Editor) => void;
export declare const wrapToUnderline: (cm: CodeMirror.Editor) => void;
export declare const wrapToMonospace: (cm: CodeMirror.Editor) => void;
export declare const wrapToMark: (cm: CodeMirror.Editor) => void;
export declare const toH1: (cm: CodeMirror.Editor) => void;
export declare const toH2: (cm: CodeMirror.Editor) => void;
export declare const toH3: (cm: CodeMirror.Editor) => void;
export declare const toH4: (cm: CodeMirror.Editor) => void;
export declare const toH5: (cm: CodeMirror.Editor) => void;
export declare const toH6: (cm: CodeMirror.Editor) => void;
export declare const colorify: (cm: CodeMirror.Editor, color: string) => void;
export declare const toCheckbox: (cm: CodeMirror.Editor) => void;
export declare const toQuote: (cm: CodeMirror.Editor) => void;
export declare const toBulletList: (cm: CodeMirror.Editor) => void;
export declare const toOrderedList: (cm: CodeMirror.Editor) => void;
export declare const toInlineCode: (cm: CodeMirror.Editor) => void;
export declare const toCodeBlock: (cm: CodeMirror.Editor) => void;
export declare const wrapToMathInline: (cm: CodeMirror.Editor) => void;
export declare const wrapToMathBlock: (cm: CodeMirror.Editor) => void;
export declare const sinkListItem: (cm: CodeMirror.Editor) => void;
export declare const liftListItem: (cm: CodeMirror.Editor) => void;
export declare const wrapToCut: (cm: CodeMirror.Editor) => void;
export declare const wrapToNote: (cm: CodeMirror.Editor) => void;
export declare const wrapToYfmBlock: (cm: CodeMirror.Editor) => void;
export declare const wrapToYfmLayout: (cm: CodeMirror.Editor) => void;
export declare const insertTable: (cm: CodeMirror.Editor) => void;
export declare const insertLink: ({ url, text, title }: {
    url: string;
    text?: string | undefined;
    title?: string | undefined;
}) => (cm: CodeMirror.Editor) => void;
export declare const insertAnchor: ({ href, text, title }?: {
    href?: string | undefined;
    text?: string | undefined;
    title?: string | undefined;
}) => (cm: CodeMirror.Editor) => void;
export declare type ImageItem = {
    url?: string;
    title?: string;
    alt?: string;
    width?: string;
    height?: string;
};
export declare function insertImages(cm: CodeMirror.Editor, images: ImageItem[]): void;
export declare const insertIframe: (cm: CodeMirror.Editor, args: {
    src: string;
    width?: number;
    height?: number;
}) => void;
export declare type FileItem = {
    src: string;
    name: string;
    type?: string;
};
export declare const insertFiles: (cm: CodeMirror.Editor, files: FileItem[]) => void;
export declare const toMermaid: (cm: CodeMirror.Editor) => void;
export declare function toHr(cm: CodeMirror.Editor): void;
export declare function toTabs(cm: CodeMirror.Editor): void;
