import type CodeMirror from 'codemirror';
import { CommonEditor, ContentHandler, MarkupString } from '../common';
export interface CodeEditor {
    readonly cm: CodeMirror.Editor;
}
export declare class Editor implements CommonEditor, CodeEditor {
    #private;
    get cm(): CodeMirror.Editor;
    get codemirror(): CodeMirror.Editor;
    constructor(cm: CodeMirror.Editor);
    focus(): void;
    hasFocus(): boolean;
    getValue(): MarkupString;
    isEmpty(): boolean;
    clear(): void;
    replace(newMarkup: MarkupString): void;
    prepend(markup: MarkupString): void;
    append(markup: MarkupString): void;
    moveCursor(position: 'start' | 'end'): void;
}
export declare class MarkupContentHandler implements ContentHandler {
    #private;
    constructor(cm: CodeMirror.Editor);
    clear(): void;
    replace(newMarkup: MarkupString): void;
    prepend(markup: MarkupString): void;
    append(markup: MarkupString): void;
    moveCursor(position: 'start' | 'end'): void;
}
