import React from 'react';
import { ToolbarLink } from '../custom/ToolbarLink';
export const WToolbarLink = ({ focus, onClick, editor, className }) => {
    const action = editor.actions.link;
    const active = action.isActive();
    const enable = action.isEnable();
    const meta = action.meta();
    return (React.createElement(ToolbarLink, { focus: focus, onClick: onClick, className: className, active: active, enable: enable, formInitialText: meta.text(), formReadOnlyText: meta.hasSelection, onSubmit: (url, text) => {
            action.run({ href: url, text: meta.hasSelection ? '' : text });
        }, removeLink: () => {
            action.run({ href: '' });
        } }));
};
