import type { RealTheme, ThemeType } from '@gravity-ui/uikit/build/esm/components/theme/types';
import { Plugin } from 'prosemirror-state';
import { EventEmitter, Receiver } from '../../../../utils/event-emitter';
export declare type WatcherEventMap = {
    'change-type': ThemeType;
    'change-theme': RealTheme;
};
export interface WatcherReceiver extends Receiver<WatcherEventMap> {
    readonly type: ThemeType;
    readonly theme: RealTheme;
}
export declare class YCThemeStore extends EventEmitter<WatcherEventMap> implements WatcherReceiver {
    #private;
    get type(): ThemeType;
    get theme(): RealTheme;
    setType(type: ThemeType): void;
    setTheme(theme: RealTheme): void;
}
export declare const ycThemeWatcherPlugin: (themeStore: Pick<YCThemeStore, 'setTheme' | 'setType'>) => Plugin<any>;
