var _YCThemeStore_type, _YCThemeStore_theme;
import { __classPrivateFieldGet, __classPrivateFieldSet } from "tslib";
import { useThemeType, useThemeValue } from '@gravity-ui/uikit';
import { Plugin } from 'prosemirror-state';
import { EventEmitter } from '../../../../utils/event-emitter';
import { getReactRendererFromState } from '../../ReactRenderer';
export class YCThemeStore extends EventEmitter {
    constructor() {
        super(...arguments);
        _YCThemeStore_type.set(this, 'light');
        _YCThemeStore_theme.set(this, 'light');
    }
    get type() {
        return __classPrivateFieldGet(this, _YCThemeStore_type, "f");
    }
    get theme() {
        return __classPrivateFieldGet(this, _YCThemeStore_theme, "f");
    }
    setType(type) {
        if (__classPrivateFieldGet(this, _YCThemeStore_type, "f") !== type) {
            __classPrivateFieldSet(this, _YCThemeStore_type, type, "f");
            this.emit('change-type', type);
        }
    }
    setTheme(theme) {
        if (__classPrivateFieldGet(this, _YCThemeStore_theme, "f") !== theme) {
            __classPrivateFieldSet(this, _YCThemeStore_theme, theme, "f");
            this.emit('change-theme', theme);
        }
    }
}
_YCThemeStore_type = new WeakMap(), _YCThemeStore_theme = new WeakMap();
export const ycThemeWatcherPlugin = (themeStore) => new Plugin({
    view: (view) => {
        const item = getReactRendererFromState(view.state).createItem('yc-theme-watcher', () => {
            const type = useThemeType();
            const theme = useThemeValue();
            themeStore.setType(type);
            themeStore.setTheme(theme);
            return null;
        });
        return {
            destroy() {
                item.remove();
            },
        };
    },
});
