import 'codemirror/addon/display/placeholder';
import { Node } from 'prosemirror-model';
import { EditorView, NodeView, NodeViewConstructor } from 'prosemirror-view';
import type { CodeMirrorViewOptions } from '..';
import type { WatcherReceiver } from '../YCThemeWatcher';
import 'codemirror/theme/nord.css';
import './CodeBlockView.css';
declare type ViewOptions = CodeMirrorViewOptions & {
    themeWatcher: WatcherReceiver;
};
export declare class CodeBlockView implements NodeView {
    static creator: (opts: ViewOptions) => NodeViewConstructor;
    dom: HTMLElement;
    private node;
    private readonly view;
    private readonly getPos;
    private readonly cm;
    private updating;
    private incomingChanges;
    private readonly themeWatcher;
    constructor(node: Node, view: EditorView, getPos: () => number | undefined, opts: ViewOptions);
    update(node: Node): boolean;
    destroy(): void;
    selectNode(): void;
    setSelection(anchor: number, head: number): void;
    stopEvent(): boolean;
    private updateCmTheme;
    private forwardSelection;
    private asProseMirrorSelection;
    private valueChanged;
    private codeMirrorKeymap;
    private onAllSelect;
    private maybeEscape;
}
export {};
