import { Selection } from 'prosemirror-state';
export function arrowHandler(dir, nodeName) {
    return (state, dispatch, view) => {
        if (state.selection.empty && (view === null || view === void 0 ? void 0 : view.endOfTextblock(dir))) {
            const side = dir === 'left' || dir === 'up' ? -1 : 1, $head = state.selection.$head;
            const nextPos = Selection.near(state.doc.resolve(side > 0 ? $head.after() : $head.before()), side);
            if (nextPos.$head && nextPos.$head.parent.type.name === nodeName) {
                dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.setSelection(nextPos));
                return true;
            }
        }
        return false;
    };
}
