import type { ExtensionAuto } from '../../core';
import { PlaceholderOptions } from '../../utils/placeholder';
import { EmojiOptions } from '../yfm/Emoji';
import { ClipboardOptions } from './Clipboard';
import { CodeBlockHighlightOptions } from './CodeBlockHighlight';
import { CommandMenuOptions } from './CommandMenu';
import { CursorOptions } from './Cursor';
import { HistoryOptions } from './History';
import { ImgSizeAdditionsOptions } from './ImgSizeAdditions';
import { LinkEnhanceOptions } from './LinkEnhance';
import { ReactRenderer } from './ReactRenderer';
import { SelectionContextOptions } from './SelectionContext';
import { YfmFileAdditionsOptions } from './YfmFileAdditions';
export * from './Cursor';
export * from './History';
export * from './Clipboard';
export * from './Selection';
export * from './Placeholder';
export * from './ReactRenderer';
export declare type BehaviorPresetOptions = {
    cursor?: CursorOptions;
    history?: HistoryOptions;
    clipboard?: ClipboardOptions;
    placeholder?: PlaceholderOptions;
    reactRenderer: ReactRenderer;
    selectionContext?: SelectionContextOptions;
    link?: LinkEnhanceOptions;
    codeBlock?: CodeBlockHighlightOptions;
    imgSize?: ImgSizeAdditionsOptions;
    yfmFile?: YfmFileAdditionsOptions;
    commandMenu?: CommandMenuOptions;
    emoji?: EmojiOptions;
};
export declare const BehaviorPreset: ExtensionAuto<BehaviorPresetOptions>;
