var _Editor_cm, _Editor_contentHandler, _MarkupContentHandler_cm;
import { __classPrivateFieldGet, __classPrivateFieldSet } from "tslib";
export class Editor {
    constructor(cm) {
        _Editor_cm.set(this, void 0);
        _Editor_contentHandler.set(this, void 0);
        __classPrivateFieldSet(this, _Editor_cm, cm, "f");
        __classPrivateFieldSet(this, _Editor_contentHandler, new MarkupContentHandler(cm), "f");
    }
    get cm() {
        return __classPrivateFieldGet(this, _Editor_cm, "f");
    }
    get codemirror() {
        return __classPrivateFieldGet(this, _Editor_cm, "f");
    }
    focus() {
        return __classPrivateFieldGet(this, _Editor_cm, "f").focus();
    }
    hasFocus() {
        return __classPrivateFieldGet(this, _Editor_cm, "f").hasFocus();
    }
    getValue() {
        return __classPrivateFieldGet(this, _Editor_cm, "f").getValue();
    }
    isEmpty() {
        return __classPrivateFieldGet(this, _Editor_cm, "f").lineCount() === 1 && __classPrivateFieldGet(this, _Editor_cm, "f").getLine(0).trim().length === 0;
    }
    clear() {
        return __classPrivateFieldGet(this, _Editor_contentHandler, "f").clear();
    }
    replace(newMarkup) {
        return __classPrivateFieldGet(this, _Editor_contentHandler, "f").replace(newMarkup);
    }
    prepend(markup) {
        return __classPrivateFieldGet(this, _Editor_contentHandler, "f").prepend(markup);
    }
    append(markup) {
        return __classPrivateFieldGet(this, _Editor_contentHandler, "f").append(markup);
    }
    moveCursor(position) {
        __classPrivateFieldGet(this, _Editor_contentHandler, "f").moveCursor(position);
    }
}
_Editor_cm = new WeakMap(), _Editor_contentHandler = new WeakMap();
export class MarkupContentHandler {
    constructor(cm) {
        _MarkupContentHandler_cm.set(this, void 0);
        __classPrivateFieldSet(this, _MarkupContentHandler_cm, cm, "f");
    }
    clear() {
        this.replace('');
    }
    replace(newMarkup) {
        __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").setValue(newMarkup);
    }
    prepend(markup) {
        const cursor = __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").getCursor();
        // eslint-disable-next-line @typescript-eslint/no-unused-expressions
        if (markup.endsWith('\n\n'))
            markup;
        else if (markup.endsWith('\n'))
            markup += '\n';
        else
            markup += '\n\n';
        const markupLinesCount = markup.split('\n').length - 1;
        this.replace(markup + __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").getValue());
        __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").setCursor({ line: cursor.line + markupLinesCount, ch: cursor.ch });
    }
    append(markup) {
        const value = __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").getValue();
        if (value === '') {
            if (markup.endsWith('\n\n'))
                this.replace(markup);
            else if (markup.endsWith('\n'))
                this.replace(markup + '\n');
            else
                this.replace(markup + '\n\n');
            this.moveCursor('end');
            return;
        }
        const cursor = __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").getCursor();
        if (value.endsWith('\n\n'))
            this.replace(value + markup);
        else if (value.endsWith('\n'))
            this.replace(value + '\n' + markup);
        else
            this.replace(value + '\n\n' + markup);
        __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").setCursor(cursor);
    }
    moveCursor(position) {
        let pos;
        switch (position) {
            case 'start':
                pos = { line: __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").firstLine(), ch: 0 };
                break;
            case 'end':
                pos = { line: __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").lastLine(), ch: Number.MAX_SAFE_INTEGER };
                break;
            default:
                throw new Error('The "position" argument must be "start" or "end"');
        }
        __classPrivateFieldGet(this, _MarkupContentHandler_cm, "f").setSelection(pos);
    }
}
_MarkupContentHandler_cm = new WeakMap();
